/*
   When playing with file filters, it is useful to know that "end of file" is
   denoted at the command-line in Windows by Ctrl-Z and by Ctrl-D in Linux.
*/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int main(int argc, char* argv[])
{
   srand( (unsigned)time(NULL) );

   int lines;
   if (argc >= 2)
   {
      lines = atoi(argv[1]); // fixed number of lines of output
   }
   else
   {
      lines = rand()%100; // random number of lines of output
   }

   for (int i = 0; i < lines; i++)
   {
      int data_points;
      if (argc >= 3)
      {
         data_points = atoi(argv[2]); // fixed number of numbers on this line of output
      }
      else
      {
         data_points = rand()%20; // random number of numbers on this line of output
      }

      if ( rand()%2 ) // "flip a coin" to decide if there should be leading spaces
      {
         int spaces = rand()%20; // random leading spaces
         for (int j = 0; j < spaces; j++)
         {
            printf(" ");
         }
      }

      for (int j = 0; j < data_points - 1; j++)
      {
         int r = rand();
         double d = (r%10000) + ( (double)r / RAND_MAX );
         printf("%.13f", d);
         printf(" ");            // at least once space between numbers
         int spaces = rand()%20; // with some extra random spaces
         for (int k = 0; k < spaces; k++)
         {
            printf(" ");
         }
      }
      int r = rand();
      double d = (r%10000) + (double)r / RAND_MAX; // last number on this line
      printf("%.13f", d);

      if ( rand()%2 ) // "flip a coin" to decide if there should be trailling spaces
      {
         int spaces = rand()%20; // random trailing spaces
         for (int k = 0; k < spaces; k++)
         {
            printf(" ");
         }
      }

      printf("\n");  // end this line
    //printf("#\n"); // end this line in a way that we can see where it ends
   }

   return 0;
}
